#ifndef __SYSCOLOR_H
#define __SYSCOLOR_H

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>
#include "I:\indiestep\working-5\lsapi\lsapi.h"
#include "I:\indiestep\working-5\lsapi\lswinbase.cpp"

#define MAX_LINE_LENGTH 4096

//==============================================================
// I'm lazy and dont really want to mess around with redefining
// the windows version so ill just include these values manually
//==============================================================
#ifndef COLOR_HOTLIGHT
#define COLOR_HOTLIGHT                  26
#endif
#ifndef COLOR_GRADIENTACTIVECAPTION
#define COLOR_GRADIENTACTIVECAPTION     27
#endif
#ifndef COLOR_GRADIENTINACTIVECAPTION
#define COLOR_GRADIENTINACTIVECAPTION   28
#endif
#ifndef SPI_GETGRADIENTCAPTIONS
#define SPI_GETGRADIENTCAPTIONS             0x1008
#endif
#ifndef SPI_SETGRADIENTCAPTIONS
#define SPI_SETGRADIENTCAPTIONS             0x1009
#endif
#ifndef SPI_GETHOTRACKING
#define SPI_GETHOTTRACKING                  0x100E
#endif
#ifndef SPI_SETHOTTRACKING
#define SPI_SETHOTTRACKING                  0x100F
#endif

//===========================================================
// Names of the color elements, need to write to the ini file
//===========================================================
char* acElements[34] = {
  "SC3DDkShadow",
  "SC3DFace",
  "SCBtnFace",
  "SC3DHiLight",
  "SC3DHighLight",
  "SCBtnHiLight",
  "SCBtnHighLight",
  "SC3DLight",
  "SC3DShadow",
  "SCBtnShadow",
  "SCActiveBorder",
  "SCActiveCaption",
  "SCAppWorkSpace",
  "SCBackground",
  "SCDesktop",
  "SCBtnText",
  "SCCaptionText",
  "SCGrayText",
  "SCHighLight",
  "SCHighLightText",
  "SCInactiveBorder",
  "SCInactiveCaption",
  "SCInactiveCaptionText",
  "SCInfoBk",
  "SCInfoText",
  "SCMenu",
  "SCMenuText",
  "SCScrollBar",
  "SCWindow",
  "SCWindowFrame",
  "SCWindowText",
  "SCGradientActiveCaption",
  "SCGradientInactiveCaption",
  "SCHotLight"
};


//===========================================================
// Window's color defines
//===========================================================
int aiElements[34] = {	
  COLOR_3DDKSHADOW,
	COLOR_3DFACE,
	COLOR_BTNFACE,
	COLOR_3DHILIGHT,
	COLOR_3DHIGHLIGHT,
	COLOR_BTNHILIGHT,
	COLOR_BTNHIGHLIGHT,
	COLOR_3DLIGHT,
	COLOR_3DSHADOW,
	COLOR_BTNSHADOW,
	COLOR_ACTIVEBORDER,
	COLOR_ACTIVECAPTION,
	COLOR_APPWORKSPACE,
	COLOR_BACKGROUND,
	COLOR_DESKTOP,
	COLOR_BTNTEXT,
	COLOR_CAPTIONTEXT,
	COLOR_GRAYTEXT,
	COLOR_HIGHLIGHT,
	COLOR_HIGHLIGHTTEXT,
	COLOR_INACTIVEBORDER,
	COLOR_INACTIVECAPTION,
	COLOR_INACTIVECAPTIONTEXT,
	COLOR_INFOBK,
	COLOR_INFOTEXT,
	COLOR_MENU,
	COLOR_MENUTEXT,
	COLOR_SCROLLBAR,
	COLOR_WINDOW,
	COLOR_WINDOWFRAME,
	COLOR_WINDOWTEXT,
  COLOR_GRADIENTACTIVECAPTION,
  COLOR_GRADIENTINACTIVECAPTION,
  COLOR_HOTLIGHT
};

class Syscolor : public Window
{
private:
  DWORD aColors[34];
  DWORD cacheColors[34];
  bool colorRGB;
  bool nochange;

  //BOOL isGradientEnabled;
  //BOOL isHotTrackingEnabled;
/*
  COLORREF c3DDkShadow;
  COLORREF c3DFace;
  COLORREF cBtnFace; // same as c3DFace
  COLORREF c3DHiLight;
  COLORREF c3DHighLight; // same as c3DHiLight
  COLORREF cBtnHiLight; // same as c3DHiLight
  COLORREF cBtnHighLight; // same as c3DHiLight
  COLORREF c3DLight;
  COLORREF c3DShadow;
  COLORREF cBtnShadow; // same as c3DShadow;
  COLORREF cActiveBorder;
  COLORREF cActiveCaption;
  COLORREF cAppWorkSpace;
  COLORREF cBackground;
  COLORREF cDesktop; // same as cBackground
  COLORREF cBtnText;
  COLORREF cCaptionText;
  COLORREF cGradientActiveCaption;
  COLORREF cGradientInactiveCaption;
  COLORREF cGrayText;
  COLORREF cHighLight;
  COLORREF cHighLightText;
  COLORREF cHotLight;
  COLORREF cInactiveBorder;
  COLORREF cInactiveCaption;
  COLORREF cInactiveCaptionText;
  COLORREF cInfoBk;
  COLORREF cInfoText;
  COLORREF cMenu;
  COLORREF cMenuText;
  COLORREF cScrollBar;
  COLORREF cWindow;
  COLORREF cWindowFrame;
  COLORREF cWindowText;
*/
  char iniPath[MAX_LINE_LENGTH];

public:
  Syscolor(HWND parentWnd, int& code);
  ~Syscolor();

  void fillaColors();
  void setColors();
  void setColor(int, LPCSTR);
  void writeIni(LPCSTR);
  void readIni(LPCSTR);
  void updateColorsWithSystem();

private:

  COLORREF toColor(LPCSTR args, COLORREF colDef);

  virtual void windowProc(Message& message);
  void onCreate(Message& message);
  void onDestroy(Message& message);
  void onEndSession(Message& message);
  void onGetRevId(Message& message);
  void onSysCommand(Message& message);

};

void BangSC3DDkShadow(HWND caller, LPCSTR args);
void BangSC3DFace(HWND caller, LPCSTR args);
void BangSCBtnFace(HWND caller, LPCSTR args);
void BangSC3DHiLight(HWND caller, LPCSTR args);
void BangSC3DHighLight(HWND caller, LPCSTR args);
void BangSCBtnHiLight(HWND caller, LPCSTR args);
void BangSCBtnHighLight(HWND caller, LPCSTR args);
void BangSC3DLight(HWND caller, LPCSTR args);
void BangSC3DShadow(HWND caller, LPCSTR args);
void BangSCBtnShadow(HWND caller, LPCSTR args);
void BangSCActiveBorder(HWND caller, LPCSTR args);
void BangSCActiveCaption(HWND caller, LPCSTR args);
void BangSCAppWorkSpace(HWND caller, LPCSTR args);
void BangSCBackground(HWND caller, LPCSTR args);
void BangSCDesktop(HWND caller, LPCSTR args);
void BangSCBtnText(HWND caller, LPCSTR args);
void BangSCCaptionText(HWND caller, LPCSTR args);
void BangSCGrayText(HWND caller, LPCSTR args);
void BangSCHighLight(HWND caller, LPCSTR args);
void BangSCHighLightText(HWND caller, LPCSTR args);
void BangSCInactiveBorder(HWND caller, LPCSTR args);
void BangSCInactiveCaption(HWND caller, LPCSTR args);
void BangSCInactiveCaptionText(HWND caller, LPCSTR args);
void BangSCInfoBk(HWND caller, LPCSTR args);
void BangSCInfoText(HWND caller, LPCSTR args);
void BangSCMenu(HWND caller, LPCSTR args);
void BangSCMenuText(HWND caller, LPCSTR args);
void BangSCScrollBar(HWND caller, LPCSTR args);
void BangSCWindow(HWND caller, LPCSTR args);
void BangSCWindowFrame(HWND caller, LPCSTR args);
void BangSCWindowText(HWND caller, LPCSTR args);
void BangSCGradientActiveCaption(HWND caller, LPCSTR args);
void BangSCGradientInactiveCaption(HWND caller, LPCSTR args);
void BangSCHotLight(HWND caller, LPCSTR args);
void BangSCReset(HWND caller, LPCSTR args);
void BangSCWriteColors(HWND caller, LPCSTR args);
void BangSCReadColors(HWND caller, LPCSTR args);

extern "C"
{
  __declspec( dllexport ) int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath);
  __declspec( dllexport ) void quitModule(HINSTANCE dllInst);
}

#endif
